package io.hackle.hackle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

class ArgumentParser {
    @Nullable
    public Boolean getBooleanArgument(@NonNull String argumentName, @NonNull Object arguments) {
        try {
            Map<String, Object> argMap = (Map<String, Object>) arguments;
            return (Boolean) argMap.get(argumentName);
        } catch (ClassCastException exception) {
            return null;
        }
    }

    @Nullable
    public Double getDoubleArgument(@NonNull String argumentName, @NonNull Object arguments) {
        try {
            Map<String, Object> argMap = (Map<String, Object>) arguments;
            return (Double) argMap.get(argumentName);
        } catch (ClassCastException exception) {
            return null;
        }
    }

    @Nullable
    public String getStringArgument(@NonNull String argumentName, @NonNull Object arguments) {
        try {
            Map<String, Object> argMap = (Map<String, Object>) arguments;
            return (String) argMap.get(argumentName);
        } catch (ClassCastException exception) {
            return null;
        }
    }

    @NonNull
    public HashMap<String, Object> getHashMapArgument(@NonNull String argumentName, @NonNull Object arguments) {
        try {
            Map<String, Object> argMap = (Map<String, Object>) arguments;
            return (argMap.get(argumentName) == null) ? new HashMap<String, Object>() : (HashMap<String, Object>) argMap.get(argumentName);
        } catch (ClassCastException exception) {
            return new HashMap<>();
        }
    }

    @Nullable
    public Integer getIntArgument(@NonNull String argumentName, @NonNull Object arguments) {
        try {
            Map<String, Object> argMap = (Map<String, Object>) arguments;
            return (Integer) argMap.get(argumentName);
        } catch (ClassCastException exception) {
            return null;
        }
    }
}